// bonDriver_pt2wdm.h : DLL AvP[VpɃGNX|[g֐`܂B
//

#pragma once

#include "ptDrvIflib.h"
#include "IBonDriver.h"

#define	PACKET_SIZE		(188)
#define	STRM_BUF_SIZE	(PACKET_SIZE * 8192)

typedef	union{
	BYTE	strmBuf[STRM_BUF_SIZE];		/* GetTsStream(BYTE **ppDst,...) pobt@ */
	struct{
		int		bufSize;
		HANDLE	hFile;
		bool	fEof;
		bool	fContinue;
		bool	fNewLine;
		int		argc;
		char	*argv[16];
		int		lineSize;
		BYTE	lineBuf[256];
		int		size;
		int		index;
		char	readBuf[0x10000];
	}param;								/* ̓t@Cpobt@ */
}aux_buf;

typedef	struct{
	BYTE	length;
	char	msg[1];
}msg_dat;

typedef	struct{							/* bZ[Wobt@ */
	int		size;
	int		index;
	char	msg[8192];
}msg_buf;

typedef	struct{
		BYTE	ptChannel;
		WORD	TsId;
		const msg_dat	*pMsg;
}ch_dat;

typedef	struct{							/* `lobt@ */
	int		count;
	int		index;
	ch_dat	ch[64];
}ch_buf;

class CBonDrvPt2Wdm : public IBonDriver2
{
public:
	static CBonDrvPt2Wdm *CreateInstance(HINSTANCE hModule,HRESULT *phr = NULL);

/* IBonDriverI[oCh */
	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

/* IBonDriver2I[oCh */
	LPCTSTR GetTunerName(void);

	const BOOL IsTunerOpening(void);
	
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);

	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

	void Release(void);

/* ÓIϐ */
	static	HANDLE	m_hMutex;

private:
	CBonDrvPt2Wdm(HINSTANCE hModule,HRESULT *phr);
	~CBonDrvPt2Wdm();

	bool	Pt2WdmOpen();
	bool	MakeFileName();
	void	LoadInitialFileParam();
	void	LoadChanelFileParam();
	bool	GetLineParam();
	void	LoadChanelParam();
	void	InitBtChanelParam();
	const msg_dat	*PutMsgBuf(const char *pMsg);
	void	MakeInitFile();
	void	MakeSetChFile();

private:
	const HINSTANCE	m_hModule;
	HANDLE	m_hPt2Wdm;

	bool	m_fBroadTerrestrial;
	bool	m_fOpen;
	bool	m_fInitFile;
	bool	m_fSetChFile;
	bool	m_fAutoMake;
	bool	m_fInitialize;

	int		m_iRcvUHF;
	int		m_iRcvCATV;
	int		m_iRcvBS;
	int		m_iRcvCS;

	int		m_iPtDevCount;
	int		m_iTunerNumber;
	int		m_iOutLNB;

	DWORD	m_dSpace;
	DWORD	m_dChannel;

	TCHAR	m_wcTunerName[32];
	TCHAR	m_wcTunerOther[32];
	TCHAR	m_wcChannelName[32];
	TCHAR	m_wcDllName[MAX_PATH];
	TCHAR	m_wcPathName[MAX_PATH];
	TCHAR	m_wcInitName[MAX_PATH];
	TCHAR	m_wcSetChName[MAX_PATH];

	aux_buf	m_sAuxBuf;
	msg_buf	m_sMsgBuf;
	ch_buf	m_sChUHF_BS;
	ch_buf	m_sChCTV_CS;
};

